Skip to main content
POST
/
v2
/
transfers
Create transfer
curl --request POST \
  --url https://api.cdp.coinbase.com/platform/v2/transfers \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "source": {
    "accountId": "account_af2937b0-9846-4fe7-bfe9-ccc22d935114",
    "asset": "usd"
  },
  "target": {
    "address": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
    "network": "base",
    "asset": "usdc"
  },
  "amount": "100.00",
  "asset": "usd",
  "execute": false,
  "validateOnly": false,
  "metadata": {
    "invoiceId": "12345",
    "reference": "Payment for invoice #12345"
  },
  "travelRule": {
    "isSelf": false,
    "isIntermediary": true,
    "originator": {
      "name": "John Doe",
      "address": {
        "line1": "123 Main St",
        "line2": "Unit 201",
        "city": "San Francisco",
        "state": "California",
        "postCode": "94105",
        "countryCode": "US"
      },
      "financialInstitution": "PayPal, Inc.",
      "vaspName": "Fidelity Digital Asset Services, LLC",
      "vaspAddress": {
        "line1": "123 Market St",
        "line2": "Suite 400",
        "city": "San Francisco",
        "state": "California",
        "postCode": "94105",
        "countryCode": "US"
      },
      "vaspIdentifier": "5493001KJTIIGC8Y1R17",
      "personalId": "123-45-6789",
      "dateOfBirth": {
        "day": "15",
        "month": "08",
        "year": "1990"
      }
    },
    "beneficiary": {
      "name": "Jane Smith",
      "address": {
        "line1": "456 Oak Ave",
        "city": "Paris",
        "postCode": "75001",
        "countryCode": "FR"
      },
      "walletType": "custodial"
    }
  }
}
'
{
  "transferId": "transfer_af2937b0-9846-4fe7-bfe9-ccc22d935114",
  "status": "quoted",
  "source": {
    "accountId": "account_af2937b0-9846-4fe7-bfe9-ccc22d935114",
    "asset": "usd"
  },
  "target": {
    "address": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
    "network": "base",
    "asset": "usdc"
  },
  "amount": "100.00",
  "asset": "usd",
  "sourceAmount": "103.50",
  "sourceAsset": "usd",
  "targetAmount": "100.00",
  "targetAsset": "usdc",
  "exchangeRate": {
    "sourceAsset": "usd",
    "targetAsset": "usdc",
    "rate": "1"
  },
  "fees": [
    {
      "type": "bank",
      "amount": "2.50",
      "asset": "usd"
    },
    {
      "type": "conversion",
      "amount": "1.00",
      "asset": "usd"
    }
  ],
  "expiresAt": "2023-10-08T14:45:00Z",
  "createdAt": "2023-10-08T14:30:00Z",
  "updatedAt": "2023-10-08T14:30:00Z",
  "metadata": {
    "invoiceId": "12345",
    "reference": "Payment for invoice #12345"
  }
}

Authorizations

Authorization
string
header
required

A JWT signed using your CDP API Key Secret, encoded in base64. Refer to the Generate Bearer Token section of our Authentication docs for information on how to generate your Bearer Token.

Headers

X-Idempotency-Key
string

An optional string request header for making requests safely retryable. When included, duplicate requests with the same key will return identical responses. Refer to our Idempotency docs for more information on using idempotency keys.

Required string length: 1 - 128

Body

application/json

A request to create a transfer.

source
Account · object
required

The source of the transfer.

Example:
{
"accountId": "account_af2937b0-9846-4fe7-bfe9-ccc22d935114",
"asset": "usd"
}
target
Account · object
required

The target of the transfer.

Example:
{
"accountId": "account_af2937b0-9846-4fe7-bfe9-ccc22d935114",
"asset": "usd"
}
amount
string
required

The amount of the transfer, as a decimal string in standard unit denomination of the asset specified by asset (e.g., "100.00" for 100 USD, "0.05" for 0.05 ETH).

Pattern: ^\+?(?:(?:0*[1-9]\d*)(?:\.\d*)?|0*\.\d*[1-9]\d*)$
Example:

"100.00"

asset
string
required

The symbol of the asset for the amount. This must be one of the assets of the source or target.

Required string length: 1 - 42
Example:

"usd"

execute
boolean
required

Whether to immediately execute the transfer. If false, the transfer will be created in quoted status and must be executed manually via the /execute endpoint.

Example:

true

amountType
enum<string>
default:source

Specifies whether the given amount is to be received by the target or taken from the source.

  • target: The transfer target receives the exact value specified in amount. Fees are added to the amount taken from the transfer source.
  • source: The transfer target receives the value specified in amount, minus any fees.
Available options:
target,
source
Example:

"source"

validateOnly
boolean
default:false

If true, validates the transfer without initiating it. If the request is valid, a 2xx will be returned. If the request is invalid, a 4xx error will be returned. The response will include an errorType, for e.g. invalid_target if the specified target cannot receive funds.

Example:

false

metadata
object

Optional metadata as key-value pairs. Use this to store additional structured information on a resource, such as customer IDs, order references, or any application-specific data. Up to 10 key/value pairs may be provided. Keys and values are both strings. Keys must be ≤ 40 characters; values must be ≤ 500 characters.

Example:
{
"customer_id": "cust_12345",
"order_reference": "order-67890"
}
travelRule
object

Travel Rule compliance information for this transfer. Required for transfers to external wallets above regulatory thresholds. Fields required differ by region and Coinbase contracting entity.

Example:
{
"isSelf": false,
"isIntermediary": false,
"originator": {
"name": "John Doe",
"address": {
"line1": "123 Main St",
"city": "San Francisco",
"state": "CA",
"postCode": "94105",
"countryCode": "US"
}
},
"beneficiary": {
"name": "Jane Smith",
"walletType": "custodial"
}
}

Response

Successfully created transfer.

A Transfer represents all the information needed to execute a transfer and tracks the lifecycle of a transfer from initiation through completion or failure.

source
Account · object
required

The source of the transfer.

Example:
{
"accountId": "account_af2937b0-9846-4fe7-bfe9-ccc22d935114",
"asset": "usd"
}
target
Account · object
required

The target of the transfer.

Example:
{
"accountId": "account_af2937b0-9846-4fe7-bfe9-ccc22d935114",
"asset": "usd"
}
transferId
string

The ID of the transfer. Required when validateOnly is false.

Example:

"transfer_af2937b0-9846-4fe7-bfe9-ccc22d935114"

status
enum<string>

The current status of the transfer, indicating what action you need to take next. Required when validateOnly is false.

Available options:
quoted,
processing,
completed,
failed
Example:

"quoted"

sourceAmount
string

The amount of the source asset that will be transferred out, as a decimal string in standard unit denomination.

Example:

"103.50"

sourceAsset
string

The asset symbol of the source amount.

Required string length: 1 - 42
Example:

"usd"

targetAmount
string

The amount of the target asset received, as a decimal string in standard unit denomination. May be omitted in the quoted state if the value cannot be guaranteed; see estimate.targetAmount for the expected value. Populated with the actual executed amount once the transfer completes.

Example:

"100.00"

targetAsset
string

The asset symbol of the target amount.

Required string length: 1 - 42
Example:

"usdc"

exchangeRate
object

Exchange rate information for currency conversion. The rate indicates how much of the target asset is equivalent to one unit of the source asset. May be omitted in the quoted state if the rate cannot be guaranteed; see estimate.exchangeRate for the expected rate. Populated with the actual executed rate once the transfer completes.

Example:
{
"sourceAsset": "usd",
"targetAsset": "usdc",
"rate": "1"
}
fees
object[]

The fees associated with this transfer. Different transfer types have different fee structures. May be omitted in the quoted state if the fees cannot be guaranteed; see estimate.fees for the expected fees. Populated with the actual fees once the transfer completes.

Example:
[
{
"type": "bank",
"amount": "20",
"asset": "usd"
},
{
"type": "conversion",
"amount": "1.00",
"asset": "usdc"
},
{
"type": "network",
"amount": "0.01",
"asset": "usdc"
}
]
estimate
object

Captures estimated values for transfers where amounts can't be guaranteed (e.g., USDC -> EURC).

The values in estimate are not modified after a transfer is executed. They are preserved as an immutable record of the original pre-execution snapshot.

The actual executed values are populated in the transfer resource post-execution.

Example:
{
"exchangeRate": {
"sourceAsset": "usdc",
"targetAsset": "eur",
"rate": "0.85"
},
"targetAmount": "85.00",
"targetAsset": "eur",
"fees": [
{
"type": "conversion",
"amount": "0.01",
"asset": "usdc"
}
],
"estimatedAt": "2023-10-08T14:30:00Z"
}
completedAt
string<date-time>

The date and time the transfer was completed.

Example:

"2025-01-01T00:05:00Z"

failureReason
string

The reason for failure, if the transfer failed. Only present when status is failed.

Example:

"Insufficient balance to complete this transfer."

expiresAt
string<date-time>

The date and time when this transfer will expire if not executed. Only present for quoted status. A new transfer must be created to obtain an updated quote after expiration. Required when validateOnly is false.

Example:

"2025-01-01T00:15:00Z"

executedAt
string<date-time>

The date and time the transfer was executed and moved to processing. Only present when status has progressed beyond quoted.

Example:

"2025-01-01T00:01:30Z"

createdAt
string<date-time>

The date and time the transfer was created. Required when validateOnly is false.

Example:

"2025-01-01T00:00:00Z"

updatedAt
string<date-time>

The date and time the transfer was last updated. Required when validateOnly is false.

Example:

"2025-01-01T00:00:00Z"

metadata
object

Optional metadata as key-value pairs. Use this to store additional structured information on a resource, such as customer IDs, order references, or any application-specific data. Up to 10 key/value pairs may be provided. Keys and values are both strings. Keys must be ≤ 40 characters; values must be ≤ 500 characters.

Example:
{
"customer_id": "cust_12345",
"order_reference": "order-67890"
}
details
object

Additional details about the transfer. For example, if the transfer was sent to a deposit destination, the information about that destination will be included in this field.

Example:
{
"depositDestination": {
"id": "depositDestination_af2937b0-9846-4fe7-bfe9-ccc22d935114"
},
"onchainTransactions": [
{
"transactionHash": "0x363cd3b3d4f49497cf5076150cd709307b90e9fc897fdd623546ea7b9313cecb",
"network": "base"
}
]
}